Ubuntu Crontab Java版本不符的问题解决Unsupported major.minor version 51.0

来源:转载


因为Lucene4.9要求Java版本最低为Java7,所以之前一直用的Java6要升级了,要不然会报如下错误:

Exception in thread "main" java.lang.UnsupportedClassVersionError: org/apache/solr/client/solrj/SolrServerException : Unsupported major.minor version 51.0 at java.lang.ClassLoader.defineClass1(Native Method) at java.lang.ClassLoader.defineClass(ClassLoader.java:634) at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142) at java.net.URLClassLoader.defineClass(URLClassLoader.java:277) at java.net.URLClassLoader.access$000(URLClassLoader.java:73) at java.net.URLClassLoader$1.run(URLClassLoader.java:212) at java.security.AccessController.doPrivileged(Native Method) at java.net.URLClassLoader.findClass(URLClassLoader.java:205) at java.lang.ClassLoader.loadClass(ClassLoader.java:321) at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:294) at java.lang.ClassLoader.loadClass(ClassLoader.java:266) at java.lang.Class.forName0(Native Method) at java.lang.Class.forName(Class.java:188) at com.guahao.task.CrontabTask.main(CrontabTask.java:30)

于是就升级了,在ubuntu /etc/profile目录下配置了Java7的JAVA_HOME,PATH之类的。

但是在通过Crontab执行java -jar的一些任务时,还是报上面的错误,而直接在命令行执行则没有问题。很明显,crontab下用的JAVA版本跟普通用户下用的JAVA版本不一致。

可通过以下方法解决:

  1. 之前通过java -jar执行jar包,可以制定java的路径,例如:
    /usr/lib/jvm/jdk1.7.0_65/bin/java -jar
  2. 在Crontab中加入JAVA_HOME,PATH等环境变量的配置,例如:
    PATH=/usr/sbin:/usr/bin:/sbin:/bin:/usr/lib/jvm/java-6-sun/binJAVA_HOME=/usr/lib/jvm/java-6-sun

问题即可解决。
PS:为什么CRONTAB没有用全局的(etc/profile)JAVA_HOME配置呢?



分享给朋友:
您可能感兴趣的文章:
随机阅读: